/*
Connor Dial
CSCI 4270
Assignment 5
3/17/2025
This is a program designed to accept strings that are entered by the user. It then takes those strings and calculates
the optimal alignment that it would take in order to align the two strings. It then displays this information to the
user!
 */

import java.util.Scanner; // Need this import for keyboard input, so I can test.

public class Main {
    public static void main(String[] args) {
        Scanner kb = new Scanner(System.in); // Create Scanner Object for keyboard input from user.

        System.out.print("Enter first sequence: "); // Prompts user to enter first sequence. NO SPACES NO SYMBOLS.
        String firstSequence = kb.nextLine(); // Accepting input from user.

        System.out.print("Enter second sequence: "); // Prompts user to enter second sequence. NO SPACES NO SYMBOLS.
        String secondSequence = kb.nextLine(); // Accepting input from user.

        int optimalDistance = calculateOptimalAlignment(firstSequence, secondSequence); // Calls the CalculateOptimalAlignment method and sets teh result as an int.

        System.out.println("Optimal Alignment Distance: " + optimalDistance); // Displays result to user.
    }

    private static int calculateOptimalAlignment(String first, String second) {
        int n = first.length(); // Length of first string set to integer n.
        int m = second.length(); // Length of second string set to integer m.
        
        int[][] matrix = new int[n + 1][m + 1]; // Create the alignment matrix.

        for (int i = 0; i <= n; i++) { // Initialize the bottom row and right column.
            matrix[i][m] = 2 * (n - i); // Make gap penalty for remaining characters in first sequence.
        }
        for (int j = 0; j <= m; j++) {
            matrix[n][j] = 2 * (m - j); // Make gap penalty for remaining characters in second sequence
        }

        for (int j = m - 1; j >= 0; j--) {
            for (int i = n - 1; i >= 0; i--) {
                if (first.charAt(i) == second.charAt(j)) {
                    matrix[i][j] = matrix[i + 1][j + 1]; // If they match, then there is no penalty.
                } else { // If they dont match then ->
                    int below = matrix[i + 1][j] + 2; // Gap in second sequence (2)
                    int right = matrix[i][j + 1] + 2; // Gap in first sequence (2)
                    int diag = matrix[i + 1][j + 1] + 1; // Mismatch penalty (1)

                    matrix[i][j] = Math.min(below, Math.min(right, diag)); // Take the minimum of the three options
                }
            }
        }

        return matrix[0][0]; // Return the optimal alignment distance so the user can see it.
    }

}
